<template>
  <v-container>
    <base-material-search-screen
      style="width: 100%"
      title="QUẢN LÝ KHO HÀNG"
      :disabled1="true"
      :disabled2="this.selected == undefined || this.selected == null || this.selected.length <= 0"
      :disabled3="this.selected == undefined || this.selected == null || this.selected.length <= 0"
      @action-1="gotoAddProduct()"
      @action-2="deleteProductDialog()"
      @action-3="addProductStorage()"
    >
      <!-- DESKTOP -->
      <v-row v-if="!isMobile()">
        <v-col class="pt-1">
          <v-data-table
            v-model="selected"
            :headers="headers"
            :items="productList"
            :single-select="singleSelect"
            :search="search"
            class="elevation-1 table-list"
            show-select
            fixed-header
            height="510"
          >
            <!-- Search -->
            <template v-slot:top>
              <v-text-field
                v-model="search"
                label="Tìm kiếm theo tên sản phẩm"
                class="mx-4 pt-5 ma-0 pb-2"
                hide-details=""
              />
            </template>
            <!-- body -->
            <template
              v-slot:item.img_url="{ item }"
            >
              <v-img
                :lazy-src="item.img_url.thumbs"
                :src="item.img_url.thumbs"
                max-height="70"
                max-width="70"
                class="ma-1 rounded-lg"
              />
            </template>
            <template v-slot:item.name="{ item }">
              <router-link
                v-slot="{ href, route, navigate, isActive, isExactActive }"
                :to="{ name: 'CHI TIET SAN PHAM', params: { id: item.id }}"
              >
                <a
                  :href="href"
                  @click="navigate"
                >{{ item.name }}</a>
              </router-link>
            </template>
            <template v-slot:item.wholesale_price="{ item }">
              {{ formatPrice(item.wholesale_price, 0) }}
            </template>
            <template v-slot:item.retail_price="{ item }">
              {{ formatPrice(item.retail_price, 0) }}
            </template>
            <template v-slot:item.real_price="{ item }">
              {{ formatPrice(item.real_price, 0) }}
            </template>
            <template v-slot:item.quatity_inventory="{ item }">
              {{ formatPrice(item.quatity_inventory, 0) }}
            </template>
          </v-data-table>
        </v-col>
      </v-row>
      <!-- END DESKTOP -->

      <!-- MOBILE -->
      <v-row v-else>
        <v-list subheader class="list-product">
            <v-subheader>SẢN PHẨM</v-subheader>

            <v-list-item
              v-for="detail in productList"
              :key="detail.code"
            >
              <v-list-item-avatar>
                <v-img
                  :alt="`${detail.name} avatar`"
                  :src="`${ JSON.parse(detail.img_url).thumbs}`"
                />
              </v-list-item-avatar>

              <v-list-item-content>
                <strong style="font-size:13pt">
                  <router-link
                    v-slot="{ href, route, navigate, isActive, isExactActive }"
                    :to="{ name: 'CHI TIET SAN PHAM', params: { id: detail.id }}"
                  >
                    <a
                      :href="href"
                      @click="navigate"
                    >{{ detail.name }}</a>
                  </router-link>
                </strong>
                <span class="pt-2 text-right">ĐVT: {{ detail.spec_name}} </span>
                <span class="pt-2 text-right">Vốn: {{ formatPrice(detail.real_price, 0) }} </span>
                <span class="pt-2 text-right"> Sỉ: {{ formatPrice(detail.wholesale_price, 0) }} </span>
                <span class="pt-2 pb-1 text-right"> Lẻ: {{ formatPrice(detail.retail_price, 0) }} </span>
                <v-progress-linear
                  :value="detail.quatity_inventory"
                  color="blue"
                  height="10"
                  striped
                />
                <span class="text-right mt-1">{{ detail.suppiler_name }} </span>
              </v-list-item-content>

              <v-list-item-icon>
                <v-row col="12">
                  <v-icon color="red" large @click="confirmDeleteProd(detail)">
                    mdi-close
                  </v-icon>
                </v-row>
                <!-- <v-row col="12">
                  <v-icon right
                     @click="orderDetailDialog(item)"
                  >
                    edit
                  </v-icon>
                </v-row> -->
              </v-list-item-icon>
            </v-list-item>
            <v-divider inset></v-divider>
          </v-list>
      </v-row>
      <!-- END MOBILE -->
      <v-row>
        <addProduct
          ref="addProductDialog"
          :v-model="dialog"
          @refeshList="getListProduct"
        />
      </v-row>
      <v-row>
        <addStorage
          ref="addStorage"
          :v-model="dialogStorage"
          @refeshList="getListProduct"
        />
      </v-row>
      <v-row>
        <dialogConfirm
          ref="dialogConfirm"
          :v-model="dialogConfirm"
          :title="titleConfirm"
          :content="contentConfirm"
          @select-ok="deleteProduct()"
        />
      </v-row>

      <v-row>
        <dialogAlert
          ref="dialogAlert"
          :v-model="dialogAlert"
        />
      </v-row>

      <v-row>
        <snackbarNew
          ref="snackNotification"
          :v-model="snackbar"
        />
      </v-row>
    </base-material-search-screen>
  </v-container>
</template>

<script>
  import axios from 'axios'
  import config from '../../config/config'
  import addProduct from '../sales/add-product'
  import addStorage from '../sales/add-storage'
  import dialogConfirm from '../dashboard/component/dialogConfirm'
  import dialogAlert from '../dashboard/component/dialogAlert'
  import snackbarNew from '../dashboard/component/snackbarNew'

  export default {
    layout: 'SaleStorage',
    components: {
      // materialCard,
      // ProgressBar,
      addProduct,
      addStorage,
      dialogConfirm,
      dialogAlert,
      snackbarNew,
    // VueEllipseProgress
    },
    props: {},
    data () {
      return {
        search: '',
        dialog: false,
        singleSelect: false,
        selected: [],
        dialogStorage: false,
        dialogConfirm: false,
        productSelected: Object,
        dialogAlert: false,
        pageCount: 0,
        itemPerPage: 5,
        bankList: [],
        productList: [],
        color: null,
        colors: ['purple', 'info', 'success', 'warning', 'error'],
        titleConfirm: 'Xác nhận',
        contentConfirm: 'Bạn có chắc chắn muốn xóa đơn hàng này không?',
        top: true,
        bottom: false,
        left: false,
        right: false,
        snackbar: false,
        snackbarContent:
          'Đã có lỗi hệ thống xảy ra, vui lòng kiểm tra lại hoặc liên hệ với admin!!!',
        pagination: {
          ascending: true,
          sortBy: 'name',
          rowsPerPage: 10,
          page: 1,
        },
        // dvt: ['GÓI', 'THÙNG', 'KG', 'CÁI', 'HỘP'],
        // productModel: {
        //   id: "",
        //   code: "",
        //   name: ""
        // },
        headers: [
          {
            text: 'IMAGE',
            sortable: false,
            value: 'img_url',
            width: '70px',
            format: (v) => v && String(v),
          },
          {
            text: 'TÊN HÀNG',
            sortable: false,
            value: 'name',
          },
          {
            text: 'ĐVT',
            sortable: false,
            value: 'spec_name',
          },
          {
            text: 'KLT',
            sortable: false,
            value: 'net',
          },
          {
            text: 'GIÁ SỈ',
            value: 'wholesale_price',
            format: (v) => v && Number(v).toFixed(2),
            align: 'right',
          },
          {
            text: 'GIÁ LẺ',
            value: 'retail_price',
            format: (v) => v && Number(v).toFixed(2),
            align: 'right',
          },
          {
            text: 'GIÁ VỐN',
            value: 'real_price',
            format: (v) => v && Number(v).toFixed(2),
            align: 'right',
          },
          {
            text: 'SL TỒN',
            value: 'quatity_inventory',
            format: (v) => v && Number(v).toFixed(2),
            align: 'right',
          },
          {
            text: 'TÌNH TRẠNG KHO',
            align: 'center',
          },
          {
            text: 'NHÀ CUNG CẤP',
            value: 'suppiler_name',
            sortable: false,
            align: 'center',
          },
          {
            text: 'NHẬP HÀNG',
            sortable: false,
            align: 'center',
          },
        ],
        items: [],
      }
    },
    computed: {
    //   ...bankState("bank", {
    //     bankList: "bankList",
    // })
    }, // end method
    created () {
      this.getListProduct()
    },
    methods: {
      gotoAddProduct () {
        this.$router.push({ name: 'THÊM SẢN PHẨM' })
      },
      isMobile() {
        if(/Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent)) {
          return true
        } else {
          return false
        }
      },
      processTableHeaders (headers) {
        console.log('headers')
        console.log(headers)
        const nested = !!headers.some((h) => h.children)

        if (nested) {
          const children = []

          const h = headers.map((h) => {
            if (h.children && h.children.length > 0) {
              children.push(...h.children)

              return {
                rowspan: 1,
                colspan: h.children.length,
                text: h.text,
                align: h.align,
              }
            }
            return {
              rowspan: 2,
              colspan: 1,
              text: h.text,
              align: h.align,
            }
          })

          return {
            children: children,
            parents: h,
          }
        }
        return {
          parents: headers,
        }
      },
      getListProduct () {
        const self = this
        // console.log("tst");
        // this.$store.dispatch('getBankList', params).then(() => {
        //   // alert(JSON.stringify(this.$store.getters.monitoringList));
        //   this.listData = this.$store.getters.bankList;
        //   // console.log(this.listData);
        // });
        axios
          .get(config.API_FAMILY + '/api/getListProduct')
          .then(function (response) {
            self.productList = response.data.data
            console.log(JSON.stringify(self.productList))
          })
      },
      filterOnlyCapsText (value, search, item) {
        return (
          value != null &&
          search != null &&
          typeof value === 'string' &&
          value.toString().toLocaleUpperCase().indexOf(search) !== -1
        )
      },
      formatPrice (value, tofix) {
        const val = (value / 1).toFixed(tofix).replace(',', '.')
        return val.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ',')
      },
      addProductDialog () {
        // Get code
        let productCode = 'SP'
        // this.$refs.addProductDialog.productModel = null;
        // this.$refs.addProductDialog.resetValid();
        const self = this

        this.$refs.addProductDialog.dialog = true

        // this.$refs.addProductDialog.productModel.code = productCode;

        // // auto focus
        this.$nextTick(function () {
          this.$refs.addProductDialog.$refs.nameproduct.focus()
          this.$refs.addProductDialog.$refs.form.reset()
          axios
            .post(config.API_FAMILY + '/api/getSeqbyName', this.seqOb)
            .then(function (response) {
              var data = response.data.data
              if (data !== undefined && data != null) {
                productCode = data.seq

                const productModel = {
                  code: '',
                  name_product: '',
                  category_code: '',
                  specification: '',
                  net: '',
                  wholesale_price: '0',
                  retail_price: '0',
                  quota_whosale: '0',
                  quatity_inventory: '0',
                  note: '',
                  img_url:
                    '{ "thumbs": "https://cf.shopee.vn/file/8add33398aa57b801cb8b05c87c8532d" }',
                  real_price: '0',
                  create_user: '1',
                }
                self.$refs.addProductDialog.productModel = productModel
                self.$refs.addProductDialog.productModel.code = productCode
              }
            })
        })
      },

      addProductStorage () {
        console.log('Add storage aaaaaa')
        console.log(this.selected)
        console.log('Add storage aaaaaa')
        if (
          this.selected !== undefined &&
          this.selected != null &&
          this.selected.length === 1
        ) {
          this.$refs.addStorage.dialog = true
          var product = this.selected[0]
          // // auto focus

          this.$nextTick(function () {
            // this.$refs.addStorage.productStorageModel = product;
            this.$refs.addStorage.productStorageModel.product_code = product.code
            this.$refs.addStorage.productStorageModel.name_product = product.name
            this.$refs.addStorage.productStorageModel.previous_price =
              product.real_price
            this.$refs.addStorage.productStorageModel.previous_DVT =
              product.specification
            this.$refs.addStorage.$refs.refDVTCu.searchDVT = 'GÓI'
            this.$refs.addStorage.productStorageModel.stock_current =
              product.quatity_inventory
            this.$refs.addStorage.productStorageModel.receipt_quatity = 0
            this.$refs.addStorage.productStorageModel.receipt_price = 0
            this.$refs.addStorage.productStorageModel.receipt_spec = ''
            this.$refs.addStorage.productStorageModel.note = ''
            this.$refs.addStorage.$refs.receiptquatity.focus()
            console.log('Nhap Kho')
            console.log(this.$refs.addStorage.productStorageModel)
          })
        } else {
          this.snackbaralert(
            this.colors[4],
            'Vui lòng chỉ chọn 1 sản phẩm để nhập kho!',
          )
        }
        console.log('AddProductStorage')
      },
      confirmDeleteProd (detail) {
        // this.$refs.dialogConfirm.title = 'Xác nhận'
        // this.$refs.dialogConfirm.text = 'Bạn có chắc chắn muốn xóa đơn hàng này không?'
        this.productSelected = detail
        this.$refs.dialogConfirm.dialog = true
      },
      deleteProductDialog () {
        console.log('deleteProductDialog')
        console.log(this.selected)
        if (
          this.selected !== undefined &&
          this.selected != null &&
          this.selected.length === 1
        ) {
          const seft = this
          const jsonReq = JSON.stringify({ product_code: this.selected[0].code })
          console.log(jsonReq)
          axios
            .post(config.API_FAMILY + '/api/delProduct', JSON.parse(jsonReq))
            .then(function (response) {
              var data = response.data.data
              if (data !== undefined && data != null) {
                // productCode = data.seq
              }
              seft.selected = []
              seft.getListProduct()
               
            })
        } else {
          this.snackbaralert(this.colors[4], 'Vui lòng chọn sẩn phẩm cần xóa!')
          this.selected = []
        }
      },
      async deleteProduct () {
        console.log('deleteProduct')
        console.log(this.productSelected)
        const seft = this
        if (this.productSelected !== undefined && this.productSelected != null) {
          const jsonReq = JSON.stringify({ product_code: this.productSelected.code })
          console.log(jsonReq)
          await axios
            .post(config.API_FAMILY + '/api/delProduct', JSON.parse(jsonReq))
            .then(function (response) {
              var data = response.data.data
              if (data !== undefined && data != null) {
                // productCode = data.seq
              }
              seft.getListProduct()
              seft.$refs.dialogConfirm.dialog = false
              seft.snackbaralert(seft.colors[3], 'Đã xóa ' + seft.productSelected.name)
            })
        } else {
          this.snackbaralert(this.colors[4], 'Vui lòng chọn sẩn phẩm cần xóa!')
          
        }
      },
      snackbaralert (...args) {
        if (args === undefined || args < 3) {
          this.$refs.snackNotification.color = this.colors[4]
          this.$refs.snackNotification.snackbarContent =
            'Đã có lỗi xảy ra, vui lòng liên hệ admin'
          this.$refs.snackNotification.snackbar = true
        } else {
          this.$refs.snackNotification.color = args[0]
          this.$refs.snackNotification.snackbarContent = args[1]
          this.$refs.snackNotification.snackbar = true
        }
      },
    },
  }
</script>
<style scroped>
.text-right {
  text-align: right;
}
.text-center {
  text-align: center;
}
table tr td {
  padding: 0 8px !important;
}

.table-list table thead tr th {
  background-color: #2196f3 !important;
  color: #ffffff;
}
/* .table-list table {
  border-collapse: collapse !important;
  border: 1px solid gray !important;
} */
.list-product .v-list-item__avatar {
  width: 100px !important;
  height: 100px !important;
}
</style>
